package at.ac.uibk.gitsearch.security.oauth2;

import org.springframework.security.oauth2.client.authentication.OAuth2AuthenticationToken;
import org.springframework.security.oauth2.client.authentication.OAuth2LoginAuthenticationToken;

public class GitSearchOAuth2AuthenticationToken extends OAuth2AuthenticationToken {

    /**
     * serialVersionUID
     */
    private static final long serialVersionUID = 1L;

    private String redirectURL;

    public GitSearchOAuth2AuthenticationToken(OAuth2LoginAuthenticationToken authenticationResult) {
        super(
            authenticationResult.getPrincipal(),
            authenticationResult.getAuthorities(),
            authenticationResult.getClientRegistration().getRegistrationId()
        );
        redirectURL =
            authenticationResult
                .getAuthorizationExchange()
                .getAuthorizationRequest()
                .getAttribute(GitSearchOAuth2AuthorizationRequestRepository.REFERER_ATTRIBUTE);
        if (redirectURL == null) redirectURL = "/";
    }

    public String getRedirectURL() {
        return redirectURL;
    }
}
